## mingw-w64-qownnotes-24.6.3-1.src.tar.zst

=== libraries/botan/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2.2)
project(Botan)

option(BUILD_WITH_SYSTEM_BOTAN "Build using system installed Botan 2 crypto library" OFF)

add_library(botan STATIC "")
add_library(Botan::Botan ALIAS botan)

target_sources(botan PRIVATE
    botanwrapper.h
    botanwrapper.cpp
)

find_package(Qt5 REQUIRED COMPONENTS Core)

target_link_libraries(botan PUBLIC Qt5::Core)

target_include_directories(botan PUBLIC ${CMAKE_CURRENT_LIST_DIR})

if(BUILD_WITH_SYSTEM_BOTAN)
    find_package(Botan2 REQUIRED)
    if(NOT TARGET Botan2::Botan2)
        message(FATAL_ERROR "Could not find system Botan 2 library using PkgConfig")
    endif()

    target_link_libraries(botan PUBLIC Botan2::Botan2)

    target_compile_definitions(botan PUBLIC USE_SYSTEM_BOTAN)

    # Instead of put next lines into else() block
    # it is better to just return
    return()
endif()


target_sources(botan PRIVATE
    botan.h
    botan.cpp
    botan_internal.h
)


# add some Botan defines for Linux
if(UNIX)
    # Append some definitions as PRIVATE only
    # if they used only in cpp and botan_internal header
    target_compile_definitions(botan PRIVATE
        BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM
    )
endif()
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    target_compile_definitions(botan PRIVATE
        BOTAN_TARGET_OS_HAS_CLOCK_GETTIME
        BOTAN_TARGET_OS_HAS_POSIX_MLOCK
        BOTAN_TARGET_OS_HAS_POSIX1
    )
endif()
if(APPLE)
    target_compile_definitions(botan PRIVATE
        BOTAN_TARGET_OS_HAS_POSIX1
    )
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_definitions(botan PUBLIC BOTAN_BUILD_COMPILER_IS_GCC)
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_definitions(botan PUBLIC BOTAN_BUILD_COMPILER_IS_CLANG)
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
    target_compile_definitions(botan PRIVATE BOTAN_BUILD_COMPILER_IS_INTEL)
endif()


if(CMAKE_SYSTEM_PROCESSOR MATCHES "(i386|i686|x86_64|AMD64)")
    if(CMAKE_SIZEOF_VOID_P EQUAL 4)
        target_compile_definitions(botan PUBLIC
            BOTAN_TARGET_CPU_IS_X86_FAMILY
            BOTAN_TARGET_ARCH_IS_X86_32
        )
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 8)
        target_compile_definitions(botan PUBLIC
            BOTAN_TARGET_CPU_IS_X86_FAMILY
            BOTAN_TARGET_ARCH_IS_X86_64
            BOTAN_TARGET_CPU_HAS_NATIVE_64BIT
        )
    endif()
endif()

if(WIN32)
    target_compile_definitions(botan PRIVATE
        BOTAN_TARGET_OS_IS_WINDOWS
        BOTAN_TARGET_OS_HAS_WIN32
        BOTAN_HAS_ENTROPY_SRC_WIN32
    )
    if(MSVC)
        # TODO Find analog for:
        # QMAKE_CXXFLAGS_EXCEPTIONS_ON = -EHs
        target_compile_options(botan PUBLIC
            "-EHs" "-wd4251" "-wd4290" "-wd4250"
        )
        target_compile_definitions(botan PRIVATE
            _SCL_SECURE_NO_WARNINGS
            _CRT_SECURE_NO_WARNINGS
        )
        target_compile_definitions(botan PUBLIC
            BOTAN_BUILD_COMPILER_IS_MSVC
        )
        if(NOT (MSVC_VERSION LESS 1900))
            # For included library binary ABI does not matter
            # so disable warning
            target_compile_definitions(botan  PRIVATE
                _ENABLE_EXTENDED_ALIGNED_STORAGE
            )
        endif()
    else()
        target_compile_options(botan PRIVATE
            "-fpermissive" "-finline-functions" "-Wno-long-long"
        )
    endif()
endif()

if(UNIX AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set_target_properties(botan PROPERTIES
        POSITION_INDEPENDENT_CODE ON
    )
    target_compile_options(botan PRIVATE
        "-fpermissive" "-finline-functions" "-Wno-long-long"
    )
endif()

if(CMAKE_SYSTEM_NAME MATCHES "(Linux|FreeBSD)")
    target_link_libraries(botan PRIVATE
        rt
    )
    target_compile_definitions(botan PRIVATE
        BOTAN_TARGET_OS_HAS_GETAUXVAL
    )
endif()

=== PKGBUILD ===
# Maintainer: Christoph Reiter <reiter.christoph@gmail.com>

_realname=qownnotes
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=24.6.3
pkgrel=1
pkgdesc="Plain-text file markdown note taking with Nextcloud/ownCloud integration"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qownnotes.org/'
msys2_repository_url='https://github.com/pbek/QOwnNotes/'
msys2_references=(
  'aur: qownnotes'
)
license=('spdx:GPL-2.0-or-later')
depends=(
  "${MINGW_PACKAGE_PREFIX}-qt6-base"
  "${MINGW_PACKAGE_PREFIX}-qt6-svg"
  "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
  "${MINGW_PACKAGE_PREFIX}-openssl"
  "${MINGW_PACKAGE_PREFIX}-qt6-websockets"
  "${MINGW_PACKAGE_PREFIX}-aspell"
  "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
)
source=("https://github.com/pbek/QOwnNotes/releases/download/v${pkgver}/qownnotes-${pkgver}.tar.xz")
sha256sums=('51d5b24b90da967183a0d10ec7c77d32094aa497aa39763599380b977afff606')

build() {
  cd "${_realname}-${pkgver}"

  qmake6 \
    QMAKE_CFLAGS_RELEASE="${CFLAGS}" \
    QMAKE_CXXFLAGS_RELEASE="${CXXFLAGS}" \
    QMAKE_LFLAGS_RELEASE="${LDFLAGS}"
  make
}

package() {
  cd "${_realname}-${pkgver}"

  # install application
  install -D -m755 release/QOwnNotes.exe "${pkgdir}${MINGW_PREFIX}/bin/QOwnNotes.exe"

  # install visuals
  install -D -m644 PBE.QOwnNotes.desktop "${pkgdir}${MINGW_PREFIX}/share/applications/PBE.QOwnNotes.desktop"
  for format in {16x16,24x24,32x32,48x48,64x64,96x96,128x128,256x256,512x512}; do
    install -D -m644 "images/icons/${format}/apps/QOwnNotes.png" "${pkgdir}${MINGW_PREFIX}/share/icons/hicolor/$format/apps/QOwnNotes.png"
  done
  install -D -m644 "images/icons/scalable/apps/QOwnNotes.svg" "${pkgdir}${MINGW_PREFIX}/share/icons/hicolor/scalable/apps/QOwnNotes.svg"

  # install languages (it looks for "qt5" even in the qt6 build)
  install -d "${pkgdir}${MINGW_PREFIX}/share/qt5/translations/"
  install -D -m644 languages/*.qm "${pkgdir}${MINGW_PREFIX}/share/qt5/translations/"
}
